#!/usr/bin/perl -w

BEGIN
{
    my $MODULE_INCLUDE_PATH = './';
    @INC = (@INC, $MODULE_INCLUDE_PATH);
}

use HomebrewCryptor;

my $cryptor = HomebrewCryptor->new('prompt' => 'Enter password to encrypt file with: ');
my $passwordVerifyCryptor = HomebrewCryptor->new('prompt' => 'Please verify password: ');

print('Enter path to file to encrypt: ');
my $inputFilePath = readline(STDIN);
chomp($inputFilePath);

print('Enter path to output file (Or nothing to write to input file): ');
my $outputFilePath = readline(STDIN);
chomp($outputFilePath);

if ($outputFilePath eq '')
{
    $outputFilePath = $inputFilePath;
}

my $firstPassword = $cryptor->getPassword();
my $secondPassword = $passwordVerifyCryptor->getPassword();

if ($firstPassword ne $secondPassword)
{
    print("Passwords done match! Try again.\n");
}
else
{
    #TODO - Could check the return value on this.
    my $returnStatus = $cryptor->encryptFileToFile($inputFilePath, $outputFilePath);

    if (!($returnStatus))
    {
	print("Problem encrypting file. Please try again.\n");
    }
    else
    {
	print("File encrypted!\n");
    }
}
