import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.reflect.Method;
import java.net.*;
import java.util.Date;

public class PolicyEngineApplet extends JApplet implements ActionListener
{
    boolean trace = true;

//    JLabel jl;
    JButton jb;
//    int mode = 0;

    String request;
    String action;
    String source;
    boolean interactive = false;

    static final String buttonText = "Get Authentication Information";
    static final String labelText = " ";

    static final String defaultRequest = "/authn_info/login_info";
    static final String defaultAction = "read";
    static final String defaultSource = "unknown";

    public void init()
    {
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("Entering init at: " + time);
}
        readParams();

	if (interactive) {
	    draw();
        } else {
            String authInfo = invokeEngine();
            returnResult (authInfo);
            submitResult ();
        }		
    }

    private void readParams() {
	String s = null;
	s = getParameter("request");
	request = (s!=null) ? s : defaultRequest;
	s = getParameter("action");
	action = (s!=null) ? s : defaultAction;
	s = getParameter("source");
	source = (s!=null) ? s : defaultSource;
	s = getParameter("interactive");
	if ((s!=null) && (s.equals("yes"))) {
            interactive = true;
        }
    }

    private void draw () {
//	jl = new JLabel(labelText, JLabel.CENTER);
	jb = new JButton(buttonText);
	Container c = getContentPane();
	c.setLayout(new BorderLayout());
//	c.add(jl, BorderLayout.SOUTH);
	c.add(jb, BorderLayout.CENTER);
	jb.addActionListener(this);
    }	

    public void actionPerformed(ActionEvent e){
	if(e.getSource() == jb) {
//	    if(mode == 0) {
		String authInfo = invokeEngine();
//		jl.setText(authInfo);
//		mode = 1;
                returnResult (authInfo);
//	    } else {
//		jl.setText(labelText);
//		mode = 0;
//	    }
	}
    }
	
    private String invokeEngine()
    {
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("Entering invokeEngine at: " + time);
}
	class SimpleLoader extends ClassLoader {}
	SimpleLoader loader = new SimpleLoader();

	Class policyEngine = null;
	try {
	    policyEngine = loader.loadClass("com.ibm.xml.policy.xacl.PolicyEngine");
	} catch(ClassNotFoundException e) {
	    System.err.println(e);
	}
		
	Class[] params = { String.class, String.class, String.class };
		
	Method invokeMethod = null;
	try {
	    invokeMethod = policyEngine.getMethod("invokeEngine", params);
	} catch(Exception e) {
	    System.err.println(e);
	}
		
	Object result=null;
	try {
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("Invoking Engine at: " + time);
}
	    result=invokeMethod.invoke(null, new Object[]{request, action, source});
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("InvokeEngine returned at: " + time);
}
	} catch(Exception e) {
	    System.err.println(e);
	}
		
	return result.toString();
    }

    private void returnResult (String result)
    {
	try {
	    getAppletContext().showDocument(
                        new URL("javascript:setAuthnInfo(\"" + result + "\")"),
                        "_self");
        } catch (MalformedURLException e) {
            System.err.println(e);
        }
    }

    private void submitResult ()
    {
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("Entering submitResult at: " + time);
}
	try {
	    getAppletContext().showDocument(
                        new URL("javascript:submit()"));
        } catch (MalformedURLException e) {
            System.err.println(e);
        }
if (trace) {
Date date = new Date();
long time = date.getTime();
System.err.println("Leaving submitResult at: " + time);
}
    }
}
