/*
 * $Id: LibertyArtifactMessage.java,v 1.3.2.1 2002/09/17 01:52:21 jsergent Exp $
 * LibertyArtifactMessage.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;

public interface LibertyArtifactMessage {
    /**
     * Gets an artifact to be used to retrieve this message.
     * Message can be retrieved at a later time using the artifact.
     * Artifacts are one-time-use only.
     * (Use LibertyArtifactManager to get the messages.)
     *
     * @param	audience Intended audience for the artifact.  Only
     *			 the named provider will be able to dereference
     *			 the artifact.
     * @return	Message artifact 
     */    
    public byte[] getArtifactFor(String audience);

    /**
     * Gets the artifact and formats a URL query.  The query string is to
     * be appended to the assertion consumer URL of a third party.
     * When the user agent is redirected to this combined URL, the third
     * party will dereference it using the ArtifactServlet to obtain the
     * message.  Note that the leading '?' is not included in the return
     * value.
     *
     * @return	URL query string component
     */
    public String getArtifactQueryFor(String audience) throws Exception;
}
