/*
 * $Id: LibertyRequestedAuthnContext.java,v 1.4.2.1 2002/09/17 01:52:24 jsergent Exp $
 * LibertyRequestedAuthnContext.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;
import java.util.Iterator;
import java.util.List;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Data bindings for the lib:AuthnContext element as found inside
 * lib:AuthnRequest.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.4.2.1 $
 */
public class LibertyRequestedAuthnContext extends XMLElement implements LibertyElement {
    private List classRefs = null;
    private String minimumClassRef = null;
    private List statementRefs = null;

    public void parse(Element e) {
	// XXX: Implement me!
    }

    public Element getElement(Document doc) {
	Element a = doc.createElementNS(LIB_NS_URI, "lib:AuthnContext");
	addAttributesTo(a);
	addChildrenTo(a);
	return a;
    }

    protected void addAttributesTo(Element a) {
    }

    protected void addChildrenTo(Element a) {
	appendNewChildNSWithText(a, LIB_NS_URI, "lib:AuthnContextMinimumClassRef",
		    minimumClassRef);
	iterateAddNewChildrenNSWithText(a, AUTHCTX_NS_URI, "AuthnContextStatementRef", statementRefs);
	iterateAddNewChildrenNSWithText(a, AUTHCTX_NS_URI, "AuthnContextClassRef", classRefs);
    }

    /**
     * Gets the list of values of the AuthnContextClassRef elements.
     * Returns a list of strings.  Each value of the list corresponds to
     * an AuthnContextClassRef element.
     * @return the list, or null if not present
     */
    public List getClassRefs() {
	return classRefs;
    }

    /**
     * Sets or clears the list of values of the AuthnContextClassRef elements.
     * Each value of the list corresponds to an AuthnContextClassRef element
     * and must be a string.
     * @param value the new list, or null.
     */
    public void setClassRefs(List value) {
	classRefs = value;
    }

    /**
     * Returns the value of the AuthnContextMinimumClassRef element.
     * @return the URI as a string, or null if not present
     */
    public String getMinimumClassRef() {
	return minimumClassRef;
    }

    /**
     * Sets or clears the value of the AuthnContextMinimumClassRef element.
     * @param value the URI as a string, or null
     */
    public void setMinimumClassRef(String value) {
	minimumClassRef = value;
    }

    /**
     * Returns the list of AuthnContextStatementRef elements.
     * Each value of the list corresponds to an AuthnContextStatementRef
     * element and must be a string.
     * @return the list, or null if not present
     */
    public List getStatementRefs() {
	return statementRefs;
    }

    /**
     * Sets or clears the list of AuthnContextStatementRef elements.
     * Each value of the list corresponds to an AuthnContextStatementRef
     * element and must be a string.
     * @param value the new list, or null
     */
    public void setStatementRefs(List value) {
	statementRefs = value;
    }
}
