/*
 * $Id: SimpleProviderDescriptor.java,v 1.3.2.1 2002/09/17 01:52:26 jsergent Exp $
 * ProviderDescriptor.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty;

import java.security.PublicKey;
import java.net.URL;
import org.apache.xml.security.keys.KeyInfo;

/**
 * Stores provisioning information for a Liberty provider.
 * XXX: Should probably eventually provide interfaces for setting stuff, too.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.3.2.1 $
 */

public abstract class SimpleProviderDescriptor implements ProviderDescriptor {
    protected String providerID = null;
    protected byte[] providerSuccinctID = null;
    protected String b64ProviderSuccinctID = null;
    protected KeyInfo keyInfo = null;
    protected URL soapEndpoint = null;
    protected URL singleLogoutURL = null;
    protected URL singleLogoutReturnURL = null;
    protected URL federationTerminationURL = null;
    protected URL federationTerminationReturnURL = null;

    public String getProviderID() { return providerID; }

    public byte[] getProviderSuccinctID() { return providerSuccinctID; }

    public String getBase64ProviderSuccinctID() { return b64ProviderSuccinctID; }

    public PublicKey getKeyInfo() {
        try {
            return keyInfo.getPublicKey();
        } catch (Exception e) {
            return null;
        }
    }

    public URL getSoapEndpoint() { return soapEndpoint; }

    public URL getSingleLogoutURL() { return singleLogoutURL; }

    public URL getSingleLogoutReturnURL() { return singleLogoutReturnURL; }

    public URL getFederationTerminationURL() { return federationTerminationURL; }

    public URL getFederationTerminationReturnURL() {
        return federationTerminationReturnURL;
    }
};
