/*
 * $Id: SAMLAudienceRestrictionCondition.java,v 1.6.2.1 2002/09/17 01:52:30 jsergent Exp $
 * SAMLAudienceRestrictionCondition.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;
import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for saml:AudienceRestrictionCondition element.  Get and
 * set methods correspond to child elements and attributes in the XML
 * schema for this element.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.6.2.1 $
 */

public class SAMLAudienceRestrictionCondition extends SAMLCondition {
    List audiences = null;

    public void parse(Element e) {
	NodeList list = e.getChildNodes();
	for (int i = 0; i < list.getLength(); i++) {
	    if (list.item(i) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(i);
	    if (isElement(child, SAML_NS_URI, "Audience")) {
		List set = getAudiences();
		if (set == null) {
		    set = new LinkedList();
		}
		set.add(child.getFirstChild().getNodeValue());
		setAudiences(set);
	    }
	}
    }
	
    public Element getElement(Document doc) {
        Element arc = doc.createElementNS(SAML_NS_URI, "saml:AudienceRestrictionCondition");
        if (audiences != null) {
            Iterator i = audiences.iterator();
            while (i.hasNext()) {
                Element aud = doc.createElementNS(SAML_NS_URI, "saml:Audience");
                aud.appendChild(doc.createTextNode(i.next().toString()));
                arc.appendChild(aud);
            }
        }
        return arc;
    }

    
    public List getAudiences() {
        return audiences;
    }

    public void setAudiences(List value) {
        audiences = value;
    }
}
