/*
 * $Id: SAMLDecisionType.java,v 1.4.2.1 2002/09/17 01:52:30 jsergent Exp $
 * SAMLElement.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;

/**
 * Enumeration for the saml:DecisionType type.
 *
 * @author Jonathan Sergent
 * @version $Revision: 1.4.2.1 $
 */

public class SAMLDecisionType {
	private String value;

	protected SAMLDecisionType(String str) {
		value = str;
	}

	public String toString() {
		return value;
	}

	public static SAMLDecisionType valueOf(String str) {
	    if (str == null) {
		return null;
	    }
	    if (str.equals("Permit")) {
		return PERMIT;
	    } else if (str.equals("Deny")) {
		return DENY;
	    } else if (str.equals("Indeterminate")) {
		return INDETERMINATE;
	    } else {
		return null;
	    }
	}

	public static final SAMLDecisionType PERMIT
		= new SAMLDecisionType("Permit");
	public static final SAMLDecisionType DENY
		= new SAMLDecisionType("Deny");
	public static final SAMLDecisionType INDETERMINATE
		= new SAMLDecisionType("Indeterminate");
}
