/*
 * $Id: SAMLSubjectLocality.java,v 1.5.2.1 2002/09/17 01:52:32 jsergent Exp $
 * SAMLSubjectLocality.java
 *
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.experimentalstuff.com/Technologies/IPL/download.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2002 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 */

package com.sun.liberty.saml;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Data bindings for saml:SubjectLocality element.  Get and set methods
 * correspond to child elements and attributes in the XML schema for this
 * element.
 * @author Jonathan Sergent 
 * @version $Revision: 1.5.2.1 $ 
 */ 

public class SAMLSubjectLocality extends SAMLElement {
    String ipAddress = null;
    String dnsAddress = null;


    public void parse(Element e) {
	setIPAddress(e.getAttributeNS(null, "IPAddress"));
	setDNSAddress(e.getAttributeNS(null, "DNSAddress"));
    }
    
    public Element getElement(Document doc) {
	Element s = doc.createElementNS(SAML_NS_URI, "saml:SubjectLocality");
	addAttributesTo(s);
	return s;
    }

    protected void addAttributesTo(Element s) {
	if (ipAddress != null) {
	    s.setAttributeNS(null, "IPAddress", ipAddress);
	}
	if (dnsAddress != null) {
	    s.setAttributeNS(null, "DNSAddress", dnsAddress);
	}
    }


    public String getIPAddress() {
	return ipAddress;
    }

    public void setIPAddress(String addr) {
	ipAddress = addr;
    }

    public String getDNSAddress() {
	return dnsAddress;
    }

    public void setDNSAddress(String addr) {
	dnsAddress = addr;
    }
}
