package ucb.eecs.sahara.sso.anp;

import ucb.eecs.sahara.sso.anp.ANPElement;
import ucb.eecs.sahara.sso.anp.saml.SAMLPQuery;
import com.sun.liberty.Config;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for anp:AuthnCapabilitiesQuery element.  Get and set
 * methods correspond to child elements and attributes in the XML schema
 * for this element.
 *
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPAuthnCapabilitiesQuery extends SAMLPQuery implements ANPElement {
    private String nonce = null;

    public void parse(Element e) {
	if (Config.debug) {
	    System.out.println("Parsing ANPAuthnCapabilitiesQuery");
	}

        NodeList list = e.getChildNodes();
        for (int j = 0; j < list.getLength(); j++) {
            if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
            Element child = (Element) list.item(j);
            if (isElement(child, ANP_NS_URI, "Nonce")) {
                setNonce(child.getFirstChild().getNodeValue());
            }
        }
    }

    public Element getElement(Document doc) {
	Element s;
	s = doc.createElementNS(ANP_NS_URI, ANP_NS_ID + ":AuthnCapabilitiesQuery");
	return s;
    }

    protected void addChildrenTo(Element s) {
        appendNewChildNSWithText(s, ANP_NS_URI,
            ANP_NS_ID + ":Nonce", nonce);
    }

    public String getNonce() {
        return nonce;
    }

    public void setNonce(String value) {
        nonce = value;
    }


}
