package ucb.eecs.sahara.sso.anp;

import ucb.eecs.sahara.sso.anp.ANPElement;
import com.sun.liberty.saml.SAMLStatement;
import java.util.List;
import java.util.LinkedList;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for anp:AuthnStatement element.  Get and set
 * methods correspond to child elements and attributes in the XML schema
 * for this element.
 *
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class ANPAuthnStatement extends SAMLStatement implements ANPElement {
    String authnResult = null;
    ANPRedirectInfo redirectInfo = null;

    public void parse(Element e) {
	NodeList list = e.getChildNodes();
	for (int j = 0; j < list.getLength(); j++) {
	    if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(j);
	    if (isElement(child, ANP_NS_URI, "AuthnResult")) {
		setAuthnResult(child.getFirstChild().getNodeValue());
	    } else if (isElement(child, ANP_NS_URI, "RedirectInfo")) {
                ANPRedirectInfo ri = new ANPRedirectInfo();
                ri.parse(child);
		setRedirectInfo(ri);
	    }
	}
    }

    public Element getElement(Document doc) {
	Element s;
	s = doc.createElementNS(ANP_NS_URI, ANP_NS_ID + ":AuthnStatement");
	addChildrenTo(s);
	return s;
    }

    protected void addChildrenTo(Element s) {
        appendNewChildNSWithText(s, ANP_NS_URI, ANP_NS_ID + ":AuthnResult",
                          authnResult);
        if (redirectInfo != null) {
            s.appendChild(redirectInfo.getElement(s.getOwnerDocument()));
        }
    }

    public String getAuthnResult() {
        return authnResult;
    }

    public void setAuthnResult(String value) {
        authnResult = value;
    }

    public ANPRedirectInfo getRedirectInfo() {
        return redirectInfo;
    }

    public void setRedirectInfo(ANPRedirectInfo value) {
        redirectInfo = value;
    }
}
