package ucb.eecs.sahara.sso.anp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public interface ANPRequestProcessor {    
    /**
     * Processes ANPRequests.  Fills in procResult as appropriate.
     * Returns an ANPRequestProcessorAction indicating what the servlet
     * should do with the response.
     *
     * @param request: The ANPRequest received
     * @param procResult: An empty ANPRequestProcResult object to be used in
     *                    responding to the request.
     * @return An ANPRequestProcessorAction indicating what to do next.
     */
    public ANPRequestProcessorAction process(HttpServletRequest httpReq,
                                             HttpServletResponse httpResp,
                			     ANPRequest request,
					     ANPRequestProcResult procResult);
}
