package ucb.eecs.sahara.sso.anp;
import javax.xml.soap.SOAPMessage;

/**
 * Common interface for messages sent over SOAP.  Allows interaction with
 * messages to be sent or received using SAAJ (javax.xml.soap.*).
 *
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */
public interface ANPSoapMessage {
    /**
     * Parses the given SOAP message and updates the object to match.
     * Note that previously set values may persist if the given query does not
     * contain values for the fields, so it is usually correct to only call this
     * method on a newly created object.
     *
     * May throw an exception if the request cannot be parsed or it contains
     * invalid data (including a signature that can't be verified).
     *
     * @param	msg	The SOAP message
     */
    public void parse(SOAPMessage msg) throws Exception;

    /**
     * Inserts the message into the body of the given SOAP message.
     *
     * @param	msg	The SOAP message
     */
    public void addToBody(SOAPMessage msg) throws Exception;
}
