package ucb.eecs.sahara.sso.anp.saml;

import com.sun.liberty.saml.SAMLSubject;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * Data bindings for samlp:Query type with Subject element.  Get and set methods
 * correspond to child elements and attributes in the XML schema for this
 * element.
 */ 

/**
 * @author Ana Sanz Merino [University of California Berkeley, 2003]
 * @version $Revision: 1.1.1.1 $
 */

public abstract class SAMLPSubjectQuery extends SAMLPQuery {
    private SAMLSubject subject = null;


    public void parse(Element e) {
	NodeList list = e.getChildNodes();
	for (int j = 0; j < list.getLength(); j++) {
	    if (list.item(j) instanceof org.w3c.dom.Text) { continue; }
	    Element child = (Element) list.item(j);
	    if (isElement(child, SAML_NS_URI, "Subject")) {
		SAMLSubject c = new SAMLSubject();
		c.parse(child);
		setSubject(c);
	    }
	}
    }
    
    protected void addChildrenTo(Element sss) {
        if (subject != null) {
            sss.appendChild(subject.getElement(sss.getOwnerDocument()));
        }
    }


    public SAMLSubject getSubject() {
        return subject;
    }

    public void setSubject(SAMLSubject value) {
        subject = value;
    }
}
