package ucb.eecs.sahara.sso.authn;

/**
 * Implements enumeration of authenticator result identifiers.
 * 
 * @author Ana Sanz Merino
 * @version $Revision: 1.1.1.1 $
 */

public class AuthenticatorResult implements Comparable {
    private final String name;
    private static int nextOrdinal = 0;
    private final int ordinal = nextOrdinal++;

    private AuthenticatorResult(String name) { this.name = name; }
    public String toString() { return name; }
    public int compareTo(Object o) {
	return ordinal - ((AuthenticatorResult) o).ordinal;
    }

    /** Authentication was successful. */
    public static final AuthenticatorResult AUTHN_SUCCESS
	= new AuthenticatorResult("AUTHN_SUCCESS");

    /** Authentication failed. */
    public static final AuthenticatorResult AUTHN_FAILED
	= new AuthenticatorResult("AUTHN_FAILED");

    /** User must be redirected to another server to complete authentication.i
      * The session information returned by the server must be forwarded to 
      * that other server.
      */
    public static final AuthenticatorResult AUTHN_REDIRECT
	= new AuthenticatorResult("AUTHN_REDIRECT");
}
